/*
    NNTPNXwb_

  2003/ 5/13 ˁ@P
*/
#pragma once
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <winsock.h>
#include <string>
#include <vector>
#include <iostream>

#pragma comment(lib, "wsock32.lib")

typedef char I8;
typedef unsigned char UI8;
typedef short int I16;
typedef unsigned short int UI16;
typedef int I32;
typedef unsigned int UI32;
typedef char * STR8;

class CNNTP {

public:

	class CGroup { // O[vNX

	public:

		CGroup();
		CGroup(std::string stInfo);

		std::string getName() const;
		I32 getStart() const;
		I32 getLast() const;

		bool setName(std::string stName);
		bool setStart(I32 i32No);
		bool setLast(I32 i32No);

		bool setInfo(std::string stLine);

	private:

		std::string m_stName;
		I32 m_i32Start,m_i32Last;

	};

	CNNTP();

	~CNNTP();

	bool logon(std::string stAddress, I16 i16Port);


	bool list();

	bool group(std::string stGroup);

	bool title(I32 i32No);

	bool article(I32 i32No);

	bool quit();

	std::vector<CGroup *>::const_iterator getFirstGroup() const;

	std::vector<CGroup *>::const_iterator getEndGroup() const;

	UI32 getGroupTime() const;

	std::string getResult() const;

	CGroup getCurrentGroup() const;

	bool clearGroup();

private:

	UI32 m_u32Addr, m_u32GroupTime;
	I16 m_i16Port;
	std::string  m_stEOL, m_stResult;
	CGroup m_gCurrent;

	bool m_bConnect;

	struct sockaddr_in m_saConnect, m_saLocal;
	SOCKET m_sConnect;

	std::vector<CGroup *> m_vGroup;

};
