/*
   OVg{@ 02

  2003/ 6/24 ˁ@P
*/
#include <windows.h>
#include <stdio.h>
#include <winsock.h>
#include <string>
#include <iostream>
#include <fstream>
#include "classes.h"

#pragma comment(lib, "wsock32.lib")

using namespace std;

bool bExit = false;

CNNTP nntp;
ofstream ofLog;

// R}h֐
bool parseLine(string stLine) {

	if (stLine.length() < 1) {
		return false;
	}

	string stCommand, stArg;

	// R}hƈ
	if (stLine.find(" ") == string::npos) {
		stCommand = stLine;
	} else {

		// ŏ̋󔒂܂ł̓R}h
		stCommand = stLine.substr(0, stLine.find(" "));

		// ŏ̋󔒈ȍ~͈
		stArg = stLine.substr(stLine.find(" ") + 1);

		while (stArg[0] == ' ') { // 擪̋󔒍폜
			stArg.erase((unsigned int)0, 1);
		}

	}

	// logoniڑjR}h
	if (stCommand == "logon") {

		nntp.logon(stArg, 119);

		cout << nntp.getResult() << endl;

		// Ot@CL^Ȃ猋ʂL^
		if (ofLog.is_open() && ofLog.good()) {
			ofLog << nntp.getResult() << endl;
		}

		return true;

	}

	// listij[XO[vꗗjR}h
	if (stCommand == "list") {

		// j[XO[vꗗ擾
		if (!nntp.list()) {

			cout << nntp.getResult() << endl;

			if (ofLog.is_open() && ofLog.good()) {
				ofLog << nntp.getResult() << endl;
			}

			return false;

		}

		// T[o[̉o
		cout << nntp.getResult() << endl;

		if (ofLog.is_open() && ofLog.good()) {
			ofLog << nntp.getResult() << endl;
		}

		// O[vJE^
		int iGroups = 0;

		std::vector<CNNTP::CGroup *>::const_iterator i;

		// 擾j[XO[v̏o
		for (i = nntp.getFirstGroup();i != nntp.getEndGroup();i++) {

			cout << (*i)->getName() << " " << (*i)->getStart() << " " << (*i)->getLast() << endl;

			if (ofLog.is_open() && ofLog.good()) {
				ofLog << (*i)->getName() << " " << (*i)->getStart() << " " << (*i)->getLast() << endl;
			}

			// O[vJE^XV
			iGroups++;

		}

		// j[XO[vo
		cout << iGroups << "groups" << endl;

		if (ofLog.is_open() && ofLog.good()) {
			ofLog << iGroups << "groups" << endl;
		}

		return true;

	}

	// searchij[XO[vjR}h
	if (stCommand == "search") {

		int iGroups = 0;

		if (stArg.length() < 1) {
			return false;
		}

		// j[XO[vꗗ擾ĂȂΎ擾
		if (nntp.getGroupTime() == 0) {
			nntp.list();
		}

		std::vector<CNNTP::CGroup *>::const_iterator i;

		// j[XO[vXgɂ̂o
		for (i = nntp.getFirstGroup();i != nntp.getEndGroup();i++) {

			if ((*i)->getName().find(stArg) != string::npos) {

				cout << (*i)->getName() << " " << (*i)->getStart() << " " << (*i)->getLast() << endl;

				if (ofLog.is_open() && ofLog.good()) {
					ofLog << (*i)->getName() << " " << (*i)->getStart() << " " << (*i)->getLast() << endl;
				}

				iGroups++;

			}

		}

		// qbgo
		cout << iGroups << "groups" << endl;

		if (ofLog.is_open() && ofLog.good()) {
			ofLog << iGroups << "groups" << endl;
		}

		return true;

	}

	// groupij[XO[vIjR}h
	if (stCommand == "group") {

		if (stArg.length() < 1) {
			return false;
		}

		// j[XO[vI
		nntp.group(stArg);

		cout << nntp.getResult() << endl;

		if (ofLog.is_open() && ofLog.good()) {
			ofLog << nntp.getResult() << endl;
		}

		return true;

	}

	// articleiL擾jR}h
	if (stCommand == "article") {

		if (stArg.length() < 1) {
			return false;
		}

		// L擾
		nntp.article(atoi(stArg.c_str()));

		cout << nntp.getResult() << endl;

		if (ofLog.is_open() && ofLog.good()) {

			string stTmp;

			for (unsigned int i = 0;i < nntp.getResult().length();i++) {
				if (nntp.getResult()[i] != '\r') {
					stTmp += nntp.getResult()[i];
				}
			}

			ofLog << stTmp << endl;

		}

		return true;

	}

	// titlei^Cg\jR}h
	if (stCommand == "title") {

		if (stArg.length() < 1) {
			return false;
		}

		// wԍL̃^Cg擾
		nntp.title(atoi(stArg.c_str()));

		cout << nntp.getResult() << endl;

		if (ofLog.is_open() && ofLog.good()) {
			ofLog << nntp.getResult() << endl;
		}

		return true;

	}

	// titlesi^CgꗗjR}h
	if (stCommand == "titles") {

		int iArg = -1;

		// Ȃ𐔒l
		if (stArg.length() > 0) {
			iArg = atoi(stArg.c_str());
		}

		int iStart = nntp.getCurrentGroup().getStart();
		int iLast = nntp.getCurrentGroup().getLast();

		// Jnԍݒ
		if (iArg > iStart) {
			iStart = iArg;
		}

		if (iStart > iLast) {
			return false;
		}

		// L̃^Cg擾
		for (int i = iStart;i <= iLast;i++) {

			if (nntp.title(i)) {

				cout << i << " " << nntp.getResult() << endl;

				if (ofLog.is_open() && ofLog.good()) {
					ofLog << i << " " << nntp.getResult() << endl;
				}

			}

			// ESCL[Ă璆f
			if (GetAsyncKeyState(VK_ESCAPE) < 0) {

				cout << "break" << endl;

				if (ofLog.is_open() && ofLog.good()) {
					ofLog << "break" << endl;
				}

				break;

			}

		}

		return true;

	}

	// titlesi^CgꗗjR}h
	if (stCommand == "searchtitle") {

		if (stArg.length() <1) {
			return false;
		}

		int iStart = nntp.getCurrentGroup().getStart();
		int iLast = nntp.getCurrentGroup().getLast();

		if (iStart > iLast) {
			return false;
		}

		// L̃^Cg擾
		for (int i = iStart;i <= iLast;i++) {

			if (nntp.title(i) && nntp.getResult().find(stArg) != string::npos) {

				cout << i << " " << nntp.getResult() << endl;

				if (ofLog.is_open() && ofLog.good()) {
					ofLog << i << " " << nntp.getResult() << endl;
				}

			}

			// ESCL[Ă璆f
			if (GetAsyncKeyState(VK_ESCAPE) < 0) {

				cout << "break" << endl;

				if (ofLog.is_open() && ofLog.good()) {
					ofLog << "break" << endl;
				}

				break;

			}

		}

		return true;

	}

	// quitiؒfjR}h
	if (stCommand == "quit") {

		// ؒfs
		nntp.quit();

		cout << nntp.getResult() << endl;

		if (ofLog.is_open() && ofLog.good()) {
			ofLog << nntp.getResult() << endl;
		}

		return true;

	}

	// logiOt@C擾jR}h
	if (stCommand == "log") {

		if (stArg.length() <1) {
			return false;
		}

		// łɋL^Ȃ炻̃t@C
		if (ofLog.is_open()) {
			ofLog.close();
		}

		// t@CI[v
		ofLog.open(stArg.c_str());

		if (!ofLog.good()) {

			ofLog.close();

			return false;

		}

		cout << "Ot@C:" << stArg.c_str() << "L^Jn" << endl;

		return true;

	}

	// scriptiXNvgsjR}h
	if (stCommand == "script") {

		char aszLine[512];

		if (stArg.length() <1) {
			return false;
		}

		// w肳ꂽt@CJ
		ifstream scFile(stArg.c_str(), ios::nocreate);

		if (scFile.fail()) {
			return false;
		}

		// t@C̊ess
		while (scFile.good()) {

			// s擾
			scFile.getline(aszLine, 512);

			if (strlen(aszLine) > 0) {

				cout << aszLine << endl;

				if (ofLog.is_open() && ofLog.good()) {
					ofLog << aszLine << endl;
				}

				// XNvgs
				parseLine(aszLine);

			}

		}

		// t@C
		scFile.close();

		return true;

	}

	// exitivOIjR}h
	if (stCommand == "exit") {

		// ItOZbg
		bExit = true;

		return true;

	}

	// helpiR}hꗗjR}h
	if (stCommand == "help") {

		cout << "OVg{@R}hꗗ" << endl << endl;

		cout << "logon\tAhX\tNNTPT[o[ɐڑ" << endl;
		cout << "list\tj[XO[vXg\" << endl;
		cout << "search \tL[[h\tL[[hŃj[XO[v" << endl;
		cout << "group\tO[v\tj[XO[vI" << endl;
		cout << "titles\tj[XO[vL̃^Cgꗗ" << endl;
		cout << "titles\tԍ\tj[XO[vL̃^Cgꗗiwԍȍ~j" << endl;
		cout << "title\tԍ\tj[XO[v̎wԍL̃^Cg\" << endl;
		cout << "searchtitle\tL[[h\tL[[hŋL^Cg" << endl;
		cout << "article\tԍ\twԍ̋L\" << endl;
		cout << "quit\tT[o[Ƃ̐ڑ؂" << endl;
		cout << "log\tt@C\tt@CŃO擾" << endl;
		cout << "script\tt@C\tXNvgt@Cs" << endl;
		cout << "exit\tvOI" << endl;

		if (ofLog.is_open() && ofLog.good()) {

			ofLog << "OVg{@R}hꗗ" << endl << endl;

			ofLog << "logon\tAhX\tNNTPT[o[ɐڑ" << endl;
			ofLog << "list\tj[XO[vXg\" << endl;
			ofLog << "search \tL[[h\tL[[hŃj[XO[v" << endl;
			ofLog << "group\tO[v\tj[XO[vI" << endl;
			ofLog << "titles\tj[XO[vL̃^Cgꗗ" << endl;
			ofLog << "titles\tԍ\tj[XO[vL̃^Cgꗗiwԍȍ~j" << endl;
			ofLog << "title\tԍ\tj[XO[v̎wԍL̃^Cg\" << endl;
			ofLog << "searchtitle\tL[[h\tL[[hŋL^Cg" << endl;
			ofLog << "article\tԍ\twԍ̋L\" << endl;
			ofLog << "quit\tT[o[Ƃ̐ڑ؂" << endl;
			ofLog << "log\tt@C\tt@CŃO擾" << endl;
			ofLog << "script\tt@C\tXNvgt@Cs" << endl;
			ofLog << "exit\tvOI" << endl;

		}

		return true;

	}

	cout << "ȃR}h" << endl;

	if (ofLog.is_open() && ofLog.good()) {
		ofLog << "ȃR}h" << endl;
	}

	return false;

}

main(int argc, char * argv[]) {

	WSADATA wdData;
	char aszLine[512];

	char * lpszScript = NULL;

	if (argc > 1) {
		lpszScript = argv[1];
	}

	WSAStartup(MAKEWORD(1,1),&wdData);

	// o[Wo
	cout << "OVg{@ 02 (C)2003 ˁ@P" << endl;

	// R}hs[v
	while(!bExit) {

		if (lpszScript != NULL) {

			wsprintf(aszLine, "script %s", lpszScript);

			cout << '>' << aszLine << endl;

			// ͂ꂽR}h́Es
			parseLine(aszLine);

			lpszScript = NULL;

		}

		if (bExit) {
			break;
		}

		// ݑI𒆂̃O[v\
		cout << nntp.getCurrentGroup().getName() << '>';

		// R}h
		cin.getline(aszLine, 512);

		// Ot@CɃR}hCo
		if (ofLog.is_open() && ofLog.good()) {

			ofLog << nntp.getCurrentGroup().getName() << '>';
			ofLog << aszLine << endl;

		}

		// ͂ꂽR}h́Es
		parseLine(aszLine);

	}

	// Ot@C
	if (ofLog.is_open()) {
		ofLog.close();
	}

	WSACleanup();

	return 0;

}
