/*
      NNTPNX

  2003/ 5/13 ˁ@P
*/
#include "classes.h"

using namespace std;

// O[vNXRXgN^
CNNTP::CGroup::CGroup() {

	m_i32Start = -1;
	m_i32Last = -1;

}

string CNNTP::CGroup::getName() const {
	return m_stName;
}

I32 CNNTP::CGroup::getStart() const {
	return m_i32Start;
}

I32 CNNTP::CGroup::getLast() const {
	return m_i32Last;
}

bool CNNTP::CGroup::setName(string stName) {

	m_stName = stName;

	return true;

}

bool CNNTP::CGroup::setStart(I32 i32No) {

	m_i32Start = i32No;

	return true;

}

bool CNNTP::CGroup::setLast(I32 i32No) {

	m_i32Last = i32No;

	return true;

}

// O[vݒ
bool CNNTP::CGroup::setInfo(string stLine) {

	// ͕stLine̍ŏ̋󔒂܂łO[vɐݒ
	m_stName = stLine.substr(0, stLine.find(" "));

	// ͕̍ŏ̋󔒂܂ł폜
	stLine.erase(0,stLine.find(" "));

	// ͕̐擪̋󔒂폜
	while (stLine[0] == ' ') {
		stLine.erase((UI32)0, 1);
	}

	// ͕̍ŏ̋󔒂܂ł𐔒lJnLԍɐݒ
	m_i32Start = atoi((stLine.substr(0, stLine.find(" "))).c_str());

	// ͕̍ŏ̋󔒂܂ł폜
	stLine.erase(0,stLine.find(" "));

	// ͕̐擪̋󔒂폜
	while (stLine[0] == ' ') {
		stLine.erase((UI32)0, 1);
	}

	// ͕̍ŏ̋󔒂܂ł𐔒lI[Lԍɐݒ
	m_i32Last = atoi((stLine.substr(0, stLine.find(" "))).c_str());

	return true;

}

CNNTP::CGroup::CGroup(string stInfo) {
	setInfo(stInfo);
}

CNNTP::CNNTP() {

	m_i16Port = 119;
	m_u32Addr = 0;
	m_u32GroupTime = 0;

	m_bConnect = false;

	m_stEOL="\r\n";

}

CNNTP::~CNNTP() {

	// ڑȂؒf
	if (m_bConnect) {
		quit();
	}

	clearGroup();

}

bool CNNTP::logon(std::string stAddress, I16 i16Port) {

	// ڑȂG[
	if (m_bConnect) {
		return false;
	}

	m_u32Addr = inet_addr(stAddress.c_str());
	m_i16Port = i16Port;

	if (m_u32Addr == 0xffffffff) { // 񐔒lAhX

		struct hostent *host;

		host = gethostbyname(stAddress.c_str());

		if (host == NULL) { // ȃAhX

			m_stResult = "Connect Error!";

			return false;

		}

		m_u32Addr = *((unsigned long *)((host->h_addr_list)[0]));

	}

	// ڑp\Pbg쐬
	m_sConnect = socket(PF_INET, SOCK_STREAM, 0);

	ZeroMemory(&m_saConnect, sizeof(sockaddr_in));
	ZeroMemory(&m_saLocal, sizeof(sockaddr_in));

	m_saLocal.sin_family = AF_INET;
	m_saLocal.sin_addr.s_addr = INADDR_ANY;
	m_saLocal.sin_port = 0;

	bind(m_sConnect,(LPSOCKADDR)&m_saLocal,sizeof(m_saLocal));

	// ڑ쐬
	m_saConnect.sin_family = AF_INET;
	m_saConnect.sin_addr.s_addr = m_u32Addr;
	m_saConnect.sin_port = htons(m_i16Port);

	// T[o[ɐڑ
	if (connect(m_sConnect, (sockaddr *)(&m_saConnect), sizeof(m_saConnect)) == SOCKET_ERROR) {

		m_stResult = "Connect Error!";

		// \Pbgj
		shutdown(m_sConnect, 2);
		closesocket(m_sConnect);

		return false;

	}

	string stLine;
	char c;

	// T[o[̉擾
	while (recv(m_sConnect, &c, 1, 0) == 1 && c != '\n') {
		stLine += c;
	}

	if (stLine[stLine.length() - 1] == '\r') {
		stLine.erase(stLine.length() - 1, 1);
	}

	if (stLine[0] == '2') { // ڑ

		m_stResult = stLine;

		// ڑtOZbg
		m_bConnect = true;

	} else { // ڑs

		m_stResult = "Logon Error!";

		// ڑtOZbg
		m_bConnect = false;

		// I𒆃O[vNA
		m_gCurrent.setName("");
		m_gCurrent.setStart(-1);
		m_gCurrent.setLast(-1);

		// \Pbgj
		shutdown(m_sConnect, 2);
		closesocket(m_sConnect);

	}

	// I𒆃O[vNA
	m_gCurrent.setName("");
	m_gCurrent.setStart(-1);
	m_gCurrent.setLast(-1);

	return m_bConnect;

}

bool CNNTP::list() {

	if (!m_bConnect) {
		return false;
	}

	string stLine;
	string stCommand = "LIST\r\n";

	send(m_sConnect, stCommand.c_str(), stCommand.length(), 0);

	char c = 0;
	stLine = "";

	clearGroup();

	// T[o[ŏ̈s̉擾
	while (c != '\n') {

		recv(m_sConnect, &c, 1, 0);
		stLine += c;

	}

	// \n
	stLine.erase(stLine.length() - 1, 1);

	// \r
	if (stLine[stLine.length() - 1] == '\r') {
		stLine.erase(stLine.length() - 1, 1);
	}

	m_stResult = stLine + m_stEOL;

	if (stLine[0] != '2') { // G[
		return false;
	}

	// O[vXg擾[v
	while (stLine != ".") {

		char c = 0;
		stLine = "";

		// T[o[s̉擾
		while (c != '\n') {

			recv(m_sConnect, &c, 1, 0);
			stLine += c;

		}

		// \n
		stLine.erase(stLine.length() - 1, 1);
		// \r
		if (stLine[stLine.length() - 1] == '\r') {
			stLine.erase(stLine.length() - 1, 1);
		}

		// O[vXgɎ擾O[vǉ
		if (stLine.find("215") != 0 && stLine != ".") {
			m_vGroup.push_back(new CNNTP::CGroup(stLine));
		}

	}

	m_u32GroupTime = (UI32)time(NULL);

	return true;

}

bool CNNTP::group(string stGroup) {

	// ڑłȂ΃G[
	if (!m_bConnect) {
		return false;
	}

	string stCommand;

	stCommand = "GROUP ";
	stCommand += stGroup;
	stCommand += "\r\n";

	// R}hM
	send(m_sConnect, stCommand.c_str(), stCommand.length(), 0);

	string stLine;
	char c;

	while (recv(m_sConnect, &c, 1, 0) == 1 && c != '\n') {
		stLine += c;
	}

	if (stLine[stLine.length() - 1] == '\r') {
		stLine.erase(stLine.length() - 1, 1);
	}

	m_stResult = stLine;

	m_gCurrent.getName();

	while (stLine[0] == ' ') {
		stLine.erase(0,1);
	}

	stLine.erase(0,stLine.find(" "));

	while (stLine[0] == ' ') {
		stLine.erase(0,1);
	}

	m_gCurrent.setName(stGroup);

	stLine.erase(0,stLine.find(" "));

	while (stLine[0] == ' ') {
		stLine.erase(0,1);
	}

	m_gCurrent.setStart(atoi((stLine. substr(0, stLine.find(" "))).c_str()));

	stLine.erase(0,stLine.find(" "));

	while (stLine[0] == ' ') {
		stLine.erase(0,1);
	}

	m_gCurrent.setLast(atoi((stLine. substr(0, stLine.find(" "))).c_str()));

	return true;

}

bool CNNTP::title(I32 i32No) {

	if (!m_bConnect) {
		return false;
	}

	I8 aszCommand[64];

	sprintf(aszCommand, "STAT %d\r\n", i32No);

	// LIR}hM
	send(m_sConnect, aszCommand, strlen(aszCommand), 0);

	string stLine;

	char c = 0;

	m_stResult = "";

	while (recv(m_sConnect, &c, 1, 0) == 1 && c != '\n') {
		stLine += c;
	}

	if (stLine[stLine.length() - 1] == '\r') {
		stLine.erase(stLine.length() - 1, 1);
	}

	if (stLine[0] != '2') {

		m_stResult = stLine;

		return false;

	}

	wsprintf(aszCommand, "HEAD\r\n");

	// Lwb_擾R}hM
	send(m_sConnect, aszCommand, strlen(aszCommand), 0);

	// Lwb_擾
	while (stLine != ".") {

		c = 0;
		stLine = "";

		while (c != '\n') {

			recv(m_sConnect, &c, 1, 0);
			stLine += c;

		}

		stLine.erase(stLine.length() - 1, 1);

		if (stLine[stLine.length() - 1] == '\r') {
			stLine.erase(stLine.length() - 1, 1);
		}

		// ^CgsȂۑ
		if (stLine.find("Subject:") == 0) {

			m_stResult = stLine;

			// "Subject:"폜
			m_stResult.erase(0, 8);

		}

	}

	return true;

}

bool CNNTP::article(I32 i32No) {

	if (!m_bConnect) {
		return false;
	}

	I8 aszCommand[64];

	sprintf(aszCommand, "ARTICLE %d\r\n", i32No);

	send(m_sConnect, aszCommand, strlen(aszCommand), 0);

	string stLine;

	char c = 0;

	m_stResult = "";

	while (recv(m_sConnect, &c, 1, 0) == 1 && c != '\n') {
		stLine += c;
	}

	if (stLine[stLine.length() - 1] == '\r') {
		stLine.erase(stLine.length() - 1, 1);
	}

	if (stLine[0] != '2') {

		m_stResult = stLine;

		return false;

	}

	while (stLine != ".") {

		c = 0;
		stLine = "";

		while (c != '\n') {

			recv(m_sConnect, &c, 1, 0);
			stLine += c;

		}

		stLine.erase(stLine.length() - 1, 1);

		if (stLine[stLine.length() - 1] == '\r') {
			stLine.erase(stLine.length() - 1, 1);
		}

		m_stResult += stLine + m_stEOL;

	}

	return true;

}

vector<CNNTP::CGroup *>::const_iterator CNNTP::getFirstGroup() const {
	return m_vGroup.begin();
}

vector<CNNTP::CGroup *>::const_iterator CNNTP::getEndGroup() const {
	return m_vGroup.end();
}

UI32 CNNTP::getGroupTime() const {
	return m_u32GroupTime;
}

string CNNTP::getResult() const {
	return m_stResult;
}

CNNTP::CGroup CNNTP::getCurrentGroup() const {
	return m_gCurrent;
}

bool CNNTP::clearGroup() {

	for (std::vector<CGroup *>::const_iterator i = m_vGroup.begin();i != m_vGroup.end();i++) {
		delete *i;
	}

	m_vGroup.clear();

	return true;

}

bool CNNTP::quit() {

	if (!m_bConnect) {
		return false;
	}

	string stCommand = "QUIT\r\n";

	send(m_sConnect, stCommand.c_str(), stCommand.length(), 0);

	string stLine;
	char c;

	while (recv(m_sConnect, &c, 1, 0) == 1 && c != '.') {
		stLine += c;
	}

	if (stLine[stLine.length() - 1] == '\r') {
		stLine.erase(stLine.length() - 1, 1);
	}

	m_stResult = stLine;

	m_bConnect = false;
	m_gCurrent.setName("");
	m_gCurrent.setStart(-1);
	m_gCurrent.setLast(-1);

	// \Pbgj
	shutdown(m_sConnect, 2);
	closesocket(m_sConnect);

	return true;

}
